var com_tts_util_iframe_parser = (function(){

    var iFrameRegExp = new RegExp( "\\<iframe([^\\<]*?)\\>", "gi" ),
	    domainCheckRegExp = new RegExp( ":\\/\\/(.*?)(\\/|\"|\\?|#)", "gi" ),
		attributeRegExps = buildAttributeRegexps();

    function checkSupportedDomain( url ) {

		/* Possible white list support
		var allowedDomains = {
		    "www.google.com": true,
			"www.google.de": true,
		    "www.youtube.com": true,
			"www.facebook.com": true,
			"www.facebook.de": true,
		    "w.soundcloud.com": true,
			"w.soundcloud.de": true,
		    "player.vimeo.com": true,
			"player.vimeo.de": true
	    },
	    matchResult,
	    domain;

	    domainCheckRegExp.lastIndex = 0;
	    matchResult = domainCheckRegExp.exec( url );
	    if( matchResult && matchResult.length > 1 ) {
		    domain = matchResult[1].toLowerCase();
		    return typeof(allowedDomains[domain]) !== "undefined" && allowedDomains[domain];
	    }

		return false;
		*/
		return true;
    }

	function buildAttributeRegexps(){

		var allowedAttributes = {
				"src" : "string",
				"name" : "string",
				"width" : "number",
				"height" : "number",
				"marginheight" : "number",
				"marginwidth" : "number",
				"scrolling" : "string",
				"allow" : "string",
				"allowTransparency" : "string",
				"longdesc" : "string"
			},
			attributeWithValueTemplate = "=\\\"(.*?)\\\"",
			attributeRegExps = {};

		$.each( allowedAttributes, function( attributeName, type ){
			attributeRegExps[attributeName] = {
				"regExp" : new RegExp( attributeName + attributeWithValueTemplate, "gi" ),
				"type" : type
			};
		});

		return attributeRegExps;
	}

	function parseIFrameAttributes( embedCode ){

		var attributes = getAttributeStringFromIFrameTag( embedCode ),
			result = {};

		$.each( attributeRegExps, function( name, data ) {
			result[name] = findAttribute(attributes, data.regExp, data.type );
		});

		return result;
	}

    function getAttributeStringFromIFrameTag( embedCode ){

        iFrameRegExp.lastIndex = 0;

        var matchResult = iFrameRegExp.exec( embedCode );
        if( matchResult && matchResult.length > 1 ) {
            return matchResult[1];
        }

        return undefined;
    }

    function findAttribute( attributeString, regExp, type ) {

        regExp.lastIndex = 0;

        var matchResult = regExp.exec( attributeString );
        if( !matchResult || matchResult.length < 2 ) {
	        return undefined;
        }

        return ( type === "number" ) ? castAttributeToNumber( matchResult[1] ) : matchResult[1];
    }

    function castAttributeToNumber( value ) {

	    if( !value ){
		    return undefined;
	    }

	    var resultAsNumber = Number(value);
        if( isNaN(resultAsNumber) ){
            return undefined;
    	}

    	return resultAsNumber;
    }

	return {
		parseAttributes : parseIFrameAttributes,
		isDomainSupported : checkSupportedDomain
	};

})();